# Mosaic cubes

from herschel.pacs.spg.pipeline.spg_spec_tools import *

# the "sey" are the not required parameters
sey, pixelSize, interpolatePixelSize, sey, sey, sey, source, mapType = determineMappingAlgorithm(meanRebinnedCubesOn_resid,camera)
slicedInterpolatedOnCubes = None
slicedInterpolatedEquidistantOnCubes = None
slicedProjectedOnCubes = None
slicedProjectedEquidistantOnCubes = None
slicedInterpolatedOffCubes = None
slicedInterpolatedEquidistantOffCubes = None
slicedProjectedOffCubes = None
slicedProjectedEquidistantOffCubes = None

cam = "b"
if camera == "red": cam="r"

upsample = getUpsample(obs)
if source != "point": largeStep = MAX([obs.meta["pointStep"].value,obs.meta["lineStep"].value]) # to check for the non-overlapping tiling obsids
equidistantWaveGrid = wavelengthGrid(sCubesOn, oversample=2, upsample = upsample, calTree = calTree, regularGrid = True, fracMinBinSize = 0.35)

cubetype = "unknown"

if source !='point':
  if ((mapType == "oversampled") | (mapType == "nyquist")):
    sCubesOn = specProject(meanRebinnedCubesOn_resid,outputPixelsize=pixelSize)
    sCubesOn = centerRaDecMetaData(sCubesOn)
    sCubesOffA = specProject(meanRebinnedCubesOffA_resid,outputPixelsize=pixelSize)
    sCubesOffA = centerRaDecMetaData(sCubesOffA)
    sCubesOffB = specProject(meanRebinnedCubesOffB_resid,outputPixelsize=pixelSize)
    sCubesOffB = centerRaDecMetaData(sCubesOffB)
    sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
    sCubesEquiOffA = specRegridWavelength(sCubesOffA, equidistantWaveGrid)
    sCubesEquiOffB = specRegridWavelength(sCubesOffB, equidistantWaveGrid)
    filenOn = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_ON_"+str(slice).zfill(2)+".fits"
    filenOffA = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_OFFA_"+str(slice).zfill(2)+".fits"
    filenOffB = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_OFFB_"+str(slice).zfill(2)+".fits"
    cubetype = "projected"
  else:
    # This bit is unique to the HPDPs: it is not part of the SPG, however we find that this works better
    if (largeStep < 44.0):
      sCubesOn = specInterpolate(meanRebinnedCubesOn_resid,outputPixelsize=interpolatePixelSize)
      sCubesOn = centerRaDecMetaData(sCubesOn)
      sCubesOffA = specInterpolate(meanRebinnedCubesOffA_resid,outputPixelsize=interpolatePixelSize)
      sCubesOffA = centerRaDecMetaData(sCubesOffA)
      sCubesOffB = specInterpolate(meanRebinnedCubesOffB_resid,outputPixelsize=interpolatePixelSize)
      sCubesOffB = centerRaDecMetaData(sCubesOffB)
      sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
      sCubesEquiOffA = specRegridWavelength(sCubesOffA, equidistantWaveGrid)
      sCubesEquiOffB = specRegridWavelength(sCubesOffB, equidistantWaveGrid)
      filenOn = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_ON_"+str(slice).zfill(2)+".fits"
      filenOffA = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_OFFA_"+str(slice).zfill(2)+".fits"
      filenOffB = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_OFFB_"+str(slice).zfill(2)+".fits"
      cubetype = "interpolated"
    else:
      sCubesOn = specProject(meanRebinnedCubesOn_resid,outputPixelsize=1.5)
      sCubesOn = centerRaDecMetaData(sCubesOn)
      sCubesOffA = specProject(meanRebinnedCubesOffA_resid,outputPixelsize=1.5)
      sCubesOffA = centerRaDecMetaData(sCubesOffA)
      sCubesOffB = specProject(meanRebinnedCubesOffB_resid,outputPixelsize=1.5)
      sCubesOffB = centerRaDecMetaData(sCubesOffB)
      sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
      sCubesEquiOffA = specRegridWavelength(sCubesOffA, equidistantWaveGrid)
      sCubesEquiOffB = specRegridWavelength(sCubesOffB, equidistantWaveGrid)
      filenOn = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_ON_"+str(slice).zfill(2)+".fits"
      filenOffA = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_OFFA_"+str(slice).zfill(2)+".fits"
      filenOffB = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_OFFB_"+str(slice).zfill(2)+".fits"
      cubetype = "projected"
else:
  sCubesOn = specInterpolate(meanRebinnedCubesOn_resid,outputPixelsize=interpolatePixelSize)
  sCubesOn = centerRaDecMetaData(sCubesOn)
  sCubesOffA = specInterpolate(meanRebinnedCubesOffA_resid,outputPixelsize=interpolatePixelSize)
  sCubesOffA = centerRaDecMetaData(sCubesOffA)
  sCubesOffB = specInterpolate(meanRebinnedCubesOffB_resid,outputPixelsize=interpolatePixelSize)
  sCubesOffB = centerRaDecMetaData(sCubesOffB)
  sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
  sCubesEquiOffA = specRegridWavelength(sCubesOffA, equidistantWaveGrid)
  sCubesEquiOffB = specRegridWavelength(sCubesOffB, equidistantWaveGrid)
  filenOn = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_ON_"+str(slice).zfill(2)+".fits"
  filenOffA = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_OFFA_"+str(slice).zfill(2)+".fits"
  filenOffB = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_OFFB_"+str(slice).zfill(2)+".fits"
  cubetype = "interpolated"

if cubetype == "unknown": print obsid, camera, ": something went wrong creating the mosaic cubes"
#
