## pipeline for the chop nod HPDPs

from herschel.pacs.spg.pipeline.spg_spec_tools import *
from herschel.pacs.share.util import PacsProductSinkWrapper
PacsProductSinkWrapper.getInstance().setUsed(0) 


slicedFrames = obs.level0_5.getCamera(camera).fitted.product

slicedFrames = specAddGratingCycleStatus(slicedFrames)
slicedFrames = activateMasks(slicedFrames, String1d([" "]), exclusive = True)
slicedFrames = specFlagGlitchFramesQTest(slicedFrames,copy=1)
slicedFrames = activateMasks(slicedFrames, slicedFrames.get(0).getMaskTypes())
slicedFrames = convertSignal2StandardCap(slicedFrames, calTree=calTree)
calBlock = selectSlices(slicedFrames,scical="cal").get(0)
csResponseAndDark = specDiffCs(calBlock, calTree = calTree)
slicedFrames = specSubtractDark(slicedFrames, calTree=calTree)
slicedFrames = rsrfCal(slicedFrames, calTree=calTree)
slicedFrames = specRespCal(slicedFrames, csResponseAndDark=csResponseAndDark, calTree=calTree)
slicedFrames = selectSlices(slicedFrames,scical="sci")
slicedFrames = pacsSliceContext(slicedFrames, splitOnOff=1)[0]

if aot == "PacsRangeSpec":
  isRangeScan = 1
  lineSpec = 0
if aot == "PacsLineSpec":
  isRangeScan = 0
  lineSpec = 1
shortRange = isShortRange(obs)
maskNotFF = False
copyCube = True

# flatfielding
if lineSpec or shortRange:
  ffUpsample = getUpsample(obs)
  slicedCubes = specFrames2PacsCube(slicedFrames)
  waveGrid=wavelengthGrid(slicedCubes, oversample=2, upsample=ffUpsample, calTree=calTree)
  slicedCubes = activateMasks(slicedCubes, String1d(["GLITCH","UNCLEANCHOP","NOISYPIXELS","RAWSATURATION","SATURATION","GRATMOVE", "BADPIXELS"]), exclusive = True,copy = copyCube)
  copyCube = False
  slicedCubes = specFlagOutliers(slicedCubes, waveGrid, nSigma=5, nIter=1)
  slicedCubes = activateMasks(slicedCubes, String1d(["OUTOFBAND","GLITCH","UNCLEANCHOP","NOISYPIXELS","RAWSATURATION","SATURATION","GRATMOVE", "OUTLIERS", "BADPIXELS"]), exclusive = True)
  slicedRebinnedCubes = specWaveRebin(slicedCubes, waveGrid)
  widthDetect =  2.5
  threshold   = 10.
  slicedCubesMask = maskLines(slicedCubes,slicedRebinnedCubes, lineList=[], widthDetect=widthDetect, widthMask=2.5, threshold=threshold, copy=1, verbose=0, maskType="INLINE",calTree=calTree)
  slopeInContinuum = 1
  maxr = 190.0
  # added by me
  if obsid == 1342232313: maxr = 192.0 
  slicedCubes = specFlatFieldLine(slicedCubesMask, scaling=1, copy=1, maxrange=[55.,maxr], slopeInContinuum=slopeInContinuum, maxScaling=2., maskType="OUTLIERS_FF", offset=0,calTree=calTree,verbose=0)
  slicedCubes.renameMask("OUTLIERS", "OUTLIERS_B4FF")
  slicedCubes = deactivateMasks(slicedCubes, String1d(["INLINE", "OUTLIERS_B4FF"]))
  del waveGrid, slicedRebinnedCubes, slicedCubesMask
elif isRangeScan:
    slicedFrames = specFlatFieldRange(slicedFrames,useSplinesModel=True, excludeLeaks=True, calTree = calTree, copy = copyCube)
    copyCube = False
    maskNotFF = True
    slicedCubes = specFrames2PacsCube(slicedFrames)
    slicedCubes = centerRaDecMetaData(slicedCubes)
slicedCubes = centerRaDecMetaData(slicedCubes)

lineId      = []
wavelength  = []
rasterLine  = []
rasterCol   = []
nodPosition = "" 
nodCycle    = []
scical      = ""
band        = ""
sliceNumber = []

onOff       = "ON"
sCubesOn = selectSlices(slicedCubes, lineId=lineId, wavelength=wavelength, rasterLine=rasterLine,\
         rasterCol=rasterCol, nodPosition=nodPosition, nodCycle=nodCycle, scical=scical,\
         band=band, sliceNumber=sliceNumber, onOff=onOff, verbose=0)
onOff       = "OFF"
sCubesOff = selectSlices(slicedCubes, lineId=lineId, wavelength=wavelength, rasterLine=rasterLine,\
         rasterCol=rasterCol, nodPosition=nodPosition, nodCycle=nodCycle, scical=scical,\
         band=band, sliceNumber=sliceNumber, onOff=onOff, verbose=0)
sCubesOn  = centerRaDecMetaData(sCubesOn)
sCubesOff = centerRaDecMetaData(sCubesOff)
oversample = 2
ffUpsample = getUpsample(obs)
waveGrid=wavelengthGrid(sCubesOn, oversample=oversample, upsample=ffUpsample, calTree = calTree)
sCubesOn  = activateMasks(sCubesOn,  String1d(["GLITCH","UNCLEANCHOP","SATURATION","GRATMOVE", "BADFITPIX", "BADPIXELS"]), exclusive = True, copy = copyCube)
sCubesOff = activateMasks(sCubesOff, String1d(["GLITCH","UNCLEANCHOP","SATURATION","GRATMOVE", "BADFITPIX", "BADPIXELS"]), exclusive = True, copy = copyCube)
sCubesOn  = specFlagOutliers(sCubesOn, waveGrid, nSigma=5, nIter=1)
sCubesOff = specFlagOutliers(sCubesOff, waveGrid, nSigma=5, nIter=1)
sCubesOn  = activateMasks(sCubesOn,  String1d(["OUTOFBAND", "GLITCH", "UNCLEANCHOP", "SATURATION", "GRATMOVE", "BADFITPIX", "OUTLIERS", "BADPIXELS","NOTFFED"]))
sCubesOff = activateMasks(sCubesOff, String1d(["OUTOFBAND", "GLITCH", "UNCLEANCHOP", "SATURATION", "GRATMOVE", "BADFITPIX", "OUTLIERS", "BADPIXELS","NOTFFED"]))
slicedRebinnedCubesOn = specWaveRebin(sCubesOn, waveGrid)
slicedRebinnedCubesOff = specWaveRebin(sCubesOff, waveGrid)
slicedRebinnedCubesOn  = centerRaDecMetaData(slicedRebinnedCubesOn)
slicedRebinnedCubesOff = centerRaDecMetaData(slicedRebinnedCubesOff)

# creating average on, but for the offs want to keep nod a and b separate
meanRebinnedCubesOn  = specAverageCubes(slicedRebinnedCubesOn)
meanRebinnedCubesOn  = centerRaDecMetaData(meanRebinnedCubesOn)

slicedRebinnedCubesOffA  = selectSlices(slicedRebinnedCubesOff,nodPosition=1)
meanRebinnedCubesOffA  = specAverageCubes(slicedRebinnedCubesOffA)
slicedRebinnedCubesOffB  = selectSlices(slicedRebinnedCubesOff,nodPosition=2)
meanRebinnedCubesOffB  = specAverageCubes(slicedRebinnedCubesOffB)
meanRebinnedCubesOffA = centerRaDecMetaData(meanRebinnedCubesOffA)
meanRebinnedCubesOffB = centerRaDecMetaData(meanRebinnedCubesOffB)
