# telescope background subtraction for OnOff HPDPs for chopnod observations

sey, backgroundOn = specRespCalToTelescope(meanRebinnedCubesOn, obs.auxiliary.hk,calTree=calTree)
sey, backgroundOffA = specRespCalToTelescope(meanRebinnedCubesOffA, obs.auxiliary.hk,calTree=calTree)
sey, backgroundOffB = specRespCalToTelescope(meanRebinnedCubesOffB, obs.auxiliary.hk,calTree=calTree)

meanRebinnedCubesOn_resid = meanRebinnedCubesOn.copy()
for slice in range(len(meanRebinnedCubesOn.refs)):
  cube = meanRebinnedCubesOn.get(slice)
  telbackCube = cube.copy()
  flux_obs = cube.getFlux()
  back = backgroundOn.refs[slice].product
  flux_back = back["flux_jy"].data
  newflux3d = Double3d(len(flux_back),5,5)
  for r in range(5):
    for c in range(5):
      newflux3d[:,r,c] = flux_back
  telbackCube.setFlux(newflux3d)
  blank3d=Double3d(len(flux_back),5,5)
  telbackCube["flag"].data = blank3d
  telbackCube["exposure"].data = blank3d+1
  telbackCube["stddev"].data = blank3d
  residual = subtract(ds1=cube, ds2=telbackCube)
  cube2 = meanRebinnedCubesOn_resid.get(slice)
  cube2.setFlux(residual.getFlux())
  meanRebinnedCubesOn_resid.replace(slice,cube2)
#
meanRebinnedCubesOffA_resid = meanRebinnedCubesOffA.copy() # because I want a new product with new data but keep all meta data etc
meanRebinnedCubesOffB_resid = meanRebinnedCubesOffB.copy() # because I want a new product with new data but keep all meta data etc  
for slice in range(len(meanRebinnedCubesOffA.refs)):
  cube = meanRebinnedCubesOffA.get(slice)
  telbackCube = cube.copy()
  flux_obs = cube.getFlux()
  back = backgroundOffA.refs[slice].product
  flux_back = back["flux_jy"].data
  newflux3d = Double3d(len(flux_back),5,5)
  for r in range(5):
    for c in range(5):
      newflux3d[:,r,c] = flux_back
  telbackCube.setFlux(newflux3d)
  blank3d=Double3d(len(flux_back),5,5)
  telbackCube["flag"].data = blank3d
  telbackCube["exposure"].data = blank3d+1
  telbackCube["stddev"].data = blank3d
  residual = subtract(ds1=cube, ds2=telbackCube)
  cube2 = meanRebinnedCubesOffA_resid.get(slice)
  cube2.setFlux(residual.getFlux())
  meanRebinnedCubesOffA_resid.replace(slice,cube2)

for slice in range(len(meanRebinnedCubesOffB.refs)):
  cube = meanRebinnedCubesOffB.get(slice)
  telbackCube = cube.copy()
  flux_obs = cube.getFlux()
  back = backgroundOffB.refs[slice].product
  flux_back = back["flux_jy"].data
  newflux3d = Double3d(len(flux_back),5,5)
  for r in range(5):
    for c in range(5):
      newflux3d[:,r,c] = flux_back
  telbackCube.setFlux(newflux3d)
  blank3d=Double3d(len(flux_back),5,5)
  telbackCube["flag"].data = blank3d
  telbackCube["exposure"].data = blank3d+1
  telbackCube["stddev"].data = blank3d
  residual = subtract(ds1=cube, ds2=telbackCube)
  cube2 = meanRebinnedCubesOffB_resid.get(slice)
  cube2.setFlux(residual.getFlux())
  meanRebinnedCubesOffB_resid.replace(slice,cube2)