from herschel.pacs.spg.pipeline.spg_spec_tools import *
from herschel.pacs.spg.pipeline.ProductSinkHandling import *
sink.setUsed(False)

# sey are the unused variables
sey, pixelSize, interpolatePixelSize, sey, sey, sey, source, mapType = determineMappingAlgorithm(slicedOnFinalCubes_resid,camera)
slicedInterpolatedOnCubes = None
slicedInterpolatedEquidistantOnCubes = None
slicedProjectedOnCubes = None
slicedProjectedEquidistantOnCubes = None
slicedInterpolatedOffCubes = None
slicedInterpolatedEquidistantOffCubes = None
slicedProjectedOffCubes = None
slicedProjectedEquidistantOffCubes = None

upsample = getUpsample(obs)
if source != "point": largeStep = MAX([obs.meta["pointStep"].value,obs.meta["lineStep"].value]) # to check for the non-overlapping tiling obsids
equidistantWaveGrid = wavelengthGrid(slicedCubes, oversample=2, upsample = upsample, calTree = calTree, regularGrid = True, fracMinBinSize = 0.35)

cubetype = "unknown"

# for the naming of the cubes
cam = "b"
if camera == "red": cam="r"

if source !='point':
  if ((mapType == "oversampled") | (mapType == "nyquist")):
    sCubesOn = specProject(slicedOnFinalCubes_resid,outputPixelsize=pixelSize)
    sCubesOn = centerRaDecMetaData(sCubesOn)
    sCubesOff = specProject(slicedOffFinalCubes_resid,outputPixelsize=pixelSize)
    sCubesOff = centerRaDecMetaData(sCubesOff)
    sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
    sCubesEquiOff = specRegridWavelength(sCubesOff, equidistantWaveGrid)
    filenOn = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_ON_"+str(slice).zfill(2)+".fits"
    filenOff = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_OFF_"+str(slice).zfill(2)+".fits"
    cubetype = "projected"
  else:
    # This bit is unique to the HPDPs: it is not part of the SPG, however we find that this works better
    if (largeStep < 44.0):
      sCubesOn = specInterpolate(slicedOnFinalCubes_resid,outputPixelsize=interpolatePixelSize)
      sCubesOn = centerRaDecMetaData(sCubesOn)
      sCubesOff = specInterpolate(slicedOffFinalCubes_resid,outputPixelsize=interpolatePixelSize)
      sCubesOff = centerRaDecMetaData(sCubesOff)
      sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
      sCubesEquiOff = specRegridWavelength(sCubesOff, equidistantWaveGrid)
      filenOn = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_ON_"+str(slice).zfill(2)+".fits"
      filenOff = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_OFF_"+str(slice).zfill(2)+".fits"
      cubetype = "interpolated"
    else:
      sCubesOn = specProject(slicedOnFinalCubes_resid,outputPixelsize=1.5)
      sCubesOn = centerRaDecMetaData(sCubesOn)
      sCubesOff = specProject(slicedOffFinalCubes_resid,outputPixelsize=1.5)
      sCubesOff = centerRaDecMetaData(sCubesOff)
      sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
      sCubesEquiOff = specRegridWavelength(sCubesOff, equidistantWaveGrid)
      filenOn = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_ON_"+str(slice).zfill(2)+".fits"
      filenOff = "hpacs"+str(obsid)+"_20hps3deqp"+cam+"_OFF_"+str(slice).zfill(2)+".fits"
      cubetype = "projected"
else:
  sCubesOn = specInterpolate(slicedOnFinalCubes_resid,outputPixelsize=interpolatePixelSize)
  sCubesOn = centerRaDecMetaData(sCubesOn)
  sCubesOff = specInterpolate(slicedOffFinalCubes_resid,outputPixelsize=interpolatePixelSize)
  sCubesOff = centerRaDecMetaData(sCubesOff)
  sCubesEquiOn = specRegridWavelength(sCubesOn, equidistantWaveGrid)
  sCubesEquiOff = specRegridWavelength(sCubesOff, equidistantWaveGrid)
  filenOn = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_ON_"+str(slice).zfill(2)+".fits"
  filenOff = "hpacs"+str(obsid)+"_20hps3deqi"+cam+"_OFF_"+str(slice).zfill(2)+".fits"
  cubetype = "interpolated"

if cubetype == "unknown": print obsid, camera, ": something went wrong creating the mosaic cubes"
