## This is a modification of the task used in the pipeline - the cube types and spaxel 
## sizes that were created for the HPDPs is slightly different that those created by the SPG
## pipeline

def determineMappingAlgorithmMine(obs):
  """
  if Nyquist or oversampled for the camera, then projected with 3, if pointed or tiling, 
  interpolated with 3", if very big tiling, projected with 1.5
  """
  pixelSize = 1.5
  pixelSize = 3.0
  cubeTypeB = "interpolated"
  cubeTypeR = "interpolated"
  spaxelSizeB = 3.0
  spaxelSizeR = 3.0
  #
  meta = obs.meta 
  source = meta['source'].value
  if source != "point":
    try:
      largeStep = MAX([obs.meta["pointStep"].value,obs.meta["lineStep"].value]) 
      lineStep = meta["lineStep"].value
      pointStep = meta["pointStep"].value
      numLines = meta['numRasterLines'].value
      numPoints = meta['numRasterCol'].value            
      minSteps = min(numLines, numPoints)
      stepSize = max(lineStep, pointStep)
      if stepSize <= 16 and stepSize > 3 and minSteps >= 3:
        cubeTypeB = "projected"
        spaxelSizeB = 3.0
      elif stepSize <= 3  and minSteps >= 3:
        cubeTypeB = "projected"
        spaxelSizeB = 3.0
      else:
        cubeTypeB = "interpolated"
        spaxelSizeB = 3.0
      if largeStep >= 44.0:
        cubeTypeB = "projected"
        spaxelSizeB = 1.5
      if stepSize <= 24 and stepSize > 4.5  and minSteps >= 2:
        cubeTypeR = "projected"
        spaxelSizeR = 3.0
      elif stepSize <= 4.5 and minSteps >= 2:
        cubeTypeR = "projected"
        spaxelSizeR = 3.0
      else:
        cubeTypeR = "interpolated"
        spaxelSizeR = 3.0
      if largeStep >= 44.0:
        cubeTypeR = "projected"
        spaxelSizeR = 1.5
    except:
      print obsid,camera,": no mapping information: default will be used"
  return cubeTypeB, cubeTypeR, spaxelSizeB, spaxelSizeR
